%bcond_without perl_RPC_XML_enables_mod_perl
%bcond_without perl_RPC_XML_enables_optional_test

%global cpan_name RPC-XML

Name:       perl-%{cpan_name}
Version:    0.82
Release:    1%{?dist}
Summary:    Set of classes for core data, message and XML handling
License:    (Artistic 2.0 or Artistic or LGPLv2) and (Artistic 2.0 or LGPLv2)
URL:        https://metacpan.org/release/%{cpan_name}
Source0:    https://cpan.metacpan.org/authors/id/R/RJ/RJRAY/%{cpan_name}-%{version}.tar.gz
Source1:    README.license
BuildArch:  noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.8.8
BuildRequires:  perl(ExtUtils::MakeMaker) >= 7.56
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(constant)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(HTTP::Daemon) >= 6.12
BuildRequires:  perl(HTTP::Request)
BuildRequires:  perl(HTTP::Response)
BuildRequires:  perl(HTTP::Status)
BuildRequires:  perl(IO::Handle)
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(MIME::Base64)
BuildRequires:  perl(Module::Load) >= 0.36
BuildRequires:  perl(Scalar::Util) >= 1.55
BuildRequires:  perl(subs)
BuildRequires:  perl(URI)
BuildRequires:  perl(vars)
BuildRequires:  perl(XML::LibXML) >= 1.85
BuildRequires:  perl(XML::Parser) >= 2.46
%if %{with perl_RPC_XML_enables_mod_perl}
BuildRequires:  perl(Apache)
BuildRequires:  perl(Apache::Constants)
BuildRequires:  perl(Apache::File)
BuildRequires:  perl(CGI)
%endif
BuildRequires:  perl(DateTime) >= 1.54
BuildRequires:  perl(DateTime::Format::ISO8601) >= 0.15
BuildRequires:  perl(LWP::UserAgent) >= 6.51
BuildRequires:  perl(Config)
BuildRequires:  perl(Digest::MD5)
BuildRequires:  perl(IO::Socket)
BuildRequires:  perl(IO::Socket::IP)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(LWP) >= 6.51
BuildRequires:  perl(Socket)
BuildRequires:  perl(Symbol)
BuildRequires:  perl(Test::More) >= 1.302183
%if %{with perl_RPC_XML_enables_optional_test}
BuildRequires:  perl(Compress::Zlib)
BuildRequires:  perl(Net::Server)
%endif
Requires:       perl(HTTP::Daemon) >= 6.12
Requires:       perl(MIME::Base64)
Requires:       perl(Module::Load) >= 0.36
Requires:       perl(Scalar::Util) >= 1.55
Requires:       perl(XML::Parser) >= 2.46
Suggests:       perl(Compress::Zlib)
Requires:       perl(DateTime) >= 1.54
Requires:       perl(DateTime::Format::ISO8601) >= 0.15
Requires:       perl(XML::LibXML) >= 1.85

%{?perl_default_filter}
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Module::Load|Scalar::Util|XML::LibXML|XML::Parser\\)\\s*$

%description
The RPC::XML package is an implementation of XML-RPC. The module provides
classes for sample client and server implementations, a server designed as an
Apache location-handler, and a suite of data-manipulation classes that are
used by them.


%if %{with perl_RPC_XML_enables_mod_perl}
%package -n perl-Apache-RPC
Summary:    Companion packages for RPC::XML tuned for mod_perl environments

%description -n perl-Apache-RPC
This package contains Apache::RPC::Server and Apache::RPC::Status, useful for
running RPC::XML under mod_perl.
%endif


%prep
%setup -qn %{cpan_name}-%{version}
cp -p %{SOURCE1} .
%if !%{with perl_RPC_XML_enables_mod_perl}
rm -rf lib/Apache
perl -i -ln -e 'print unless qr{^lib/Apache/}' MANIFEST
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*

%check
make test

%files
%license README.license
%doc ChangeLog* README etc/*.dtd ex/ methods/
%{_mandir}/man3/RPC*
%{_mandir}/man1/*
%{_bindir}/make_method
%{perl_vendorlib}/RPC

%if %{with perl_RPC_XML_enables_mod_perl}
%files -n perl-Apache-RPC
%license README.license
%doc README.apache2
%{_mandir}/man3/Apache*
%{perl_vendorlib}/Apache
%endif

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.82-1
- initial build
